package com.xiaomi.youpin.decrypt.demo.v2.controller;

import com.xiaomi.youpin.decrypt.demo.v2.model.Result;
import com.xiaomi.youpin.decrypt.demo.v2.model.TodoorTicket;
import com.xiaomi.youpin.decrypt.demo.v2.service.TodoorService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;


/**
 * version:2.1.1 -- 2020/7/17 14:58:51
 * 上门服务解密demo
 * 文档：https://shop.xiaomiyoupin.com/openapi/doc/openapi_v2/61-toDoorCreate.html
 */
@Slf4j
@RestController
@RequestMapping("/api/todoor")
public class TodoorController {

    @Autowired
    private TodoorService todoorService;

    @RequestMapping("/create")
    public Result create(@RequestBody Map<String, String> params) {
        try {

            String partnerId = params.get("partnerId");
            String data = params.get("data");
            String sign = params.get("sign");
            String timestamp = params.get("timestamp");

            TodoorTicket orderInfo = todoorService.parseData(partnerId, data, sign, timestamp);
            log.info("解析成功:{}", orderInfo);

            /**
             *  解析数据后，商家可在此添加业务逻辑
             */
            return Result.success();

        } catch (Exception e) {
            log.error(e.toString());
            return Result.fromException(e);
        }
    }
}
