package com.xiaomi.youpin.decrypt.demo.v2.controller;

import com.xiaomi.youpin.decrypt.demo.v2.model.Result;
import com.xiaomi.youpin.decrypt.demo.v2.model.TodoorTicket;
import com.xiaomi.youpin.decrypt.demo.v2.model.UpdateAddressInfo;
import com.xiaomi.youpin.decrypt.demo.v2.model.UpdateAddressResult;
import com.xiaomi.youpin.decrypt.demo.v2.service.UpdateAddressService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * version:2.1.1 -- 2020/7/17 14:58:51
 * V2版地址修改接口demo
 * 文档：https://shop.xiaomiyoupin.com/openapi/doc/openapi_v2/16-updateaddress.html
 */

@Slf4j
@RequestMapping("/api/address")
@RestController
public class UpdateAddressController {

    @Autowired
    private UpdateAddressService updateAddressService;

    @RequestMapping("/update")
    public UpdateAddressResult updateAddress(@RequestBody Map<String, String> params) {
        try {

            String partnerId = params.get("partnerId");
            String data = params.get("data");
            String sign = params.get("sign");
            String timestamp = params.get("timestamp");

            UpdateAddressInfo updateAddressInfo = updateAddressService.parseData(partnerId, data, sign, timestamp);
            log.info("解析成功:{}", updateAddressInfo);

            /**
             *  解析数据后，商家可在此添加业务逻辑
             */
            //UpdateAddressResult result = new UpdateAddressResult();
            return UpdateAddressResult.success(updateAddressInfo.getOrderId());

        } catch (Exception e) {
            log.error(e.toString());
            return UpdateAddressResult.fromException(e);
        }
    }
}
