package com.xiaomi.youpin.decrypt.demo.v2.enums;

import lombok.Getter;

/**
 * 希望商家服务能统一返回信息，方便监控推送情况
 *
 * 服务错误：程序运行异常，如空指针等
 * 数据错误：正常处理了数据，但不是商家所需要的数据
 *
 * 有品售后这边会根据商家服务返回信息，来调整推送服务
 */

@Getter
public enum ErrorCode {
    SIGN_ERROR(110, "签名校验失败"),
    AES_ERROR(120, "AES解密失败"),
    JSON_ERROR(130, "JSON解析错误"),
    SERVER_ERROR(210, "服务异样"),
    DATA_ERROR(310, "推送数据错误");

    private Integer code;
    private String desc;

    ErrorCode(Integer code, String desc) {
        this.code = code;
        this.desc = desc;
    }
}
