package com.xiaomi.youpin.decrypt.demo.v2.model;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.io.Serializable;
import java.util.List;

@Getter
@Setter
@ToString
public class OrderInfo {

    private OrderInfo.Address address;
    private OrderInfo.ConsigneeIdCard consigneeIdCard;
    private OrderInfo.PaymentInfo paymentInfo;
    private Long couponReduce;
    private Long activityReduce;
    private Long ctime;
    private Integer consignor;
    private String description;
    private Long ftime;
    private Integer invoiceType;
    private String invoiceTitle;
    private String invoiceCompanyCode;
    private String invoicePhone;
    private String invoiceEmail;
    private Long orderId;
    private Integer partnerId;
    private Integer orderType;
    private Long uid;
    private Long shipFee;
    private Long totalPrice;
    private List<OrderInfo.Product> productList;

    @Getter
    @Setter
    @ToString
    public static class Address implements Serializable {
        private OrderInfo.Country country;
        private OrderInfo.Province province;
        private OrderInfo.City city;
        private OrderInfo.District district;
        private OrderInfo.Area area;
        private String addressId;
        private String address;
        private String addressName;
        private String consignee;
        private String tel;
        private String zipcode;
        private Long addTime;
        private Long updateTime;
    }

    @Getter
    @Setter
    @ToString
    public static class Country implements Serializable {
        private String id;
        private String name;
    }

    @Getter
    @Setter
    @ToString
    public static class Province implements Serializable {
        private String id;
        private String name;
    }

    @Getter
    @Setter
    @ToString
    public static class City implements Serializable {
        private String id;
        private String name;
    }

    @Getter
    @Setter
    @ToString
    public static class District implements Serializable {
        private String id;
        private String name;
    }

    @Getter
    @Setter
    @ToString
    public static class Area implements Serializable {
        private String id;
        private String name;
    }

    @Getter
    @Setter
    @ToString
    public static class ConsigneeIdCard implements Serializable {
        private String cardId;
        private String cardName;
    }

    @Getter
    @Setter
    @ToString
    public static class PaymentInfo implements Serializable {
        private List<String> importationType;
    }

    @Getter
    @Setter
    @ToString
    public static class Product implements Serializable {
        private String customizedInfo;
        private Integer count;
        private Integer gid;
        private String name;
        private Integer merchantId;
        private Long pid;
        private Long price;
        private Long productPrice;
        private Long salePrice;
        private Long expressAvFee;
        private Integer status;
        private List<SkuInfo> skuInfoList;
    }

    @Getter
    @Setter
    @ToString
    public static class SkuInfo implements Serializable {
        private static final long serialVersionUID = 7765891349429338213L;

        // 实际为 pssSkuId
        private Long skuId;
        private Integer count;
    }
}
