package com.xiaomi.youpin.decrypt.demo.v2.model;

import com.xiaomi.youpin.decrypt.demo.v2.enums.ErrorCode;
import com.xiaomi.youpin.decrypt.demo.v2.errors.BizError;
import lombok.Getter;

import java.io.Serializable;

public class Result implements Serializable {

    @Getter
    private int code;

    @Getter
    private String message;


    private static String SUCCESS_MESSAGE = "ok";

    /**
     * 不允许自己创建Result，只可以使用静态方法创建
     */
    Result(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public static Result success() {
        return new Result(0, SUCCESS_MESSAGE);
    }

    public static Result fail(ErrorCode code, String message) {
        return new Result(code.getCode(), message);
    }

    public static Result fromException(Throwable e) {
        if (e instanceof BizError) {
            return new Result(((BizError) e).getCode(), ((BizError) e).getMessage());
        } else {
            return fail(ErrorCode.SERVER_ERROR, "系统繁忙，请稍后再试");
        }
    }
}
