package com.xiaomi.youpin.decrypt.demo.v2.model;

import lombok.*;

import java.io.Serializable;
import java.util.List;

@Getter
@Setter
@ToString
public class TodoorTicket {

    /**
     * 商家id
     */
    private String orgId;

    /**
     * 工单号
     */
    private String serviceId;

    /**
     * 订单号
     */
    private String orderId;

    /**
     * 服务类型:TH:退货;HH:换货;WX:维修
     */
    private String serviceType;

    /**
     * 服务方式
     */
    private String serviceWay;

    /**
     * 用户申请描述
     */
    private String customerDesc;

    /**
     * 创建时间
     */
    private Long createTime;

    /**
     * 受理物品
     */
    private List<GoodsItem> items;

    /**
     * 用户信息
     */
    private CustomerInfo customer;

    @Getter
    @Setter
    @ToString
    public static class GoodsItem implements Serializable {
        private static final long serialVersionUID = 7668818462357895307L;

        private Integer pid;

        /**
         * 商品id
         */
        private Integer sku;

        /**
         * 受理数量
         */
        private Integer quantity;
    }

    @Getter
    @Setter
    @ToString
    public static class CustomerInfo implements Serializable {
        private static final long serialVersionUID = 7668818462357667707L;

        /**
         * 国家/地区
         */
        private Integer country;

        /**
         * 省
         */
        private Integer province;

        /**
         * 市
         */
        private Integer city;

        /**
         * 区
         */
        private Integer district;

        /**
         * 街道
         */
        private Integer street;

        /**
         * 详细地址
         */
        private String address;

        /**
         * 用户电话
         */
        private String tel;

        /**
         * 用户姓名
         */
        private String name;
    }
}
