package com.xiaomi.youpin.decrypt.demo.v2.model;


import com.xiaomi.youpin.decrypt.demo.v2.enums.ErrorCode;
import com.xiaomi.youpin.decrypt.demo.v2.errors.BizError;

public class UpdateAddressResult {

    public int code;

    public AddressResponse response;

    public static class AddressResponse {

        public long orderId;

        public String status;

        public String message;

        AddressResponse(long orderId, String status, String message) {
            this.orderId = orderId;
            this.status = status;
            this.message = message;
        }
    }

    UpdateAddressResult(int code, long orderId, String status, String message) {
        this.code = code;
        this.response = new AddressResponse(orderId, status, message);
    }

    public static UpdateAddressResult success(long orderId) {
        return new UpdateAddressResult(200, orderId, "success", "");
    }

    public static UpdateAddressResult fail(long orderId, String message) {
        return new UpdateAddressResult(300, orderId, "failure", message);
    }

    public static UpdateAddressResult fromException(Throwable e) {
        if (e instanceof BizError) {
            return new UpdateAddressResult(((BizError) e).getCode(), 0L, "failure", e.getMessage());
        } else {
            return fail(0L, "系统繁忙，请稍后再试");
        }
    }
}
