package v2;

import common.OpenApiUtils;
import common.PartnerInfo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * version:2.4.0 -- 2021-01-11 11:06:06
 */
public class TestV2 {

    private static Map<String, Object> data = new HashMap<String, Object>(8);

    public static void main(String[] args) {
        String partnerId = "534";
        String name = "青岛小驴智慧网络科技有限公司";
        String aesKey = "3c7231fa2111e9c6f571107da4cb12c7";
        String key = "3a27d0df601a2f5f3cc0c82cd72d7d1e";
        PartnerInfo partnerInfo = new PartnerInfo(partnerId, name, key, aesKey);

        OpenApiUtils openapiUtils = new OpenApiUtils();
        openapiUtils.SetShop(partnerInfo);

        // 订单列表
        buildLogisticsBatchParam();
        String res = openapiUtils.api("logisticsBatch", data, "test");

//        // 单次发货
//        buildOrderListParam();
//        String res = openapiUtils.api("orderList", data, "test");

        System.out.printf("\nres: %s", res);
    }

    /**
     * 单次发货参数构建
     */
    private static void buildDeliveryParam() {
        data.put("orderId", "4191016389753901");
        data.put("expressSn", "JDV00121155113");
        data.put("bizCode", "jd");
        //data.put("userId", "XMZJ105");
        List<Map<String, Object>> itemList = new ArrayList<Map<String, Object>>();
        Map<String, Object> item = new HashMap<String, Object>();
        item.put("skuId", 3012708L);
        item.put("count", "1");
        item.put("pid", 22214L);
        itemList.add(item);
        data.put("itemList", itemList);
    }

    /**
     * 订单列表接口参数构建
     */
    private static void buildOrderListParam() {
        data.put("beginTime", 1593532800L);
        data.put("endTime", 1593878400L);
        data.put("pageNo", 1);
        data.put("pageSize", 50);
        List<Integer> status = new ArrayList<>();
        status.add(4);
        status.add(6);
        data.put("status", status);
    }

    /**
     * 批量物流接口参数构建
     */
    private static void buildLogisticsBatchParam() {
        List<Long> orderIdList = new ArrayList<>();
        orderIdList.add(4210107318604263L);
        data.put("orderIdList", orderIdList);
    }
}
