package com.xiaomiyoupin.orderpush.controller;

import com.xiaomiyoupin.orderpush.result.Result;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

@ControllerAdvice
@Slf4j
public class GlobalExceptionHandler {
    @ExceptionHandler(value = Throwable.class)
    @ResponseBody
    public Object defaultErrorHandler(HttpServletRequest req, Throwable e) {
        log.error("Error occured. host:{} url:{}, exception: ", req.getRemoteHost(), req.getRequestURL(), e);
        return Result.fromException(e);
    }
}
