package com.xiaomiyoupin.orderpush.errors;

import lombok.Getter;

import java.util.HashSet;
import java.util.Set;

public class ErrorCode {
    private static final int ERROR_CODE_PREFIX = 400;
    private static Set<Integer> allCodes = new HashSet();

    @Getter
    private int code;

    ErrorCode(int code) {
        this.code = code;
    }

    public static ErrorCode createOnce(ErrorScope errorScope, int internalCode) {
        if (internalCode >= 0 && internalCode < 1000) {
            ErrorCode code = new ErrorCode(Integer.valueOf(String.format("%03d%03d%03d", 400, errorScope.getScopeId(), internalCode)));
            if (allCodes.contains(code.getCode())) {
                throw new IllegalArgumentException("Duplicated error code defination.");
            } else {
                allCodes.add(code.getCode());
                return code;
            }
        } else {
            throw new IllegalArgumentException("Bad internal code range. " + internalCode);
        }
    }
}